Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.Designer.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.Designer.cs	(revision 9490)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.Designer.cs	(revision 9491)
@@ -67,9 +67,8 @@
       // pictureBox
       // 
-      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.pictureBox.BackColor = System.Drawing.Color.White;
-      this.pictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
       this.pictureBox.ContextMenuStrip = this.pictureBoxContextMenuStrip;
       this.pictureBox.Location = new System.Drawing.Point(0, 0);
@@ -81,6 +80,9 @@
       this.pictureBox.VisibleChanged += new System.EventHandler(this.pictureBox_VisibleChanged);
       this.pictureBox.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseDown);
+      this.pictureBox.MouseEnter += new System.EventHandler(this.pictureBox_MouseEnter);
       this.pictureBox.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseMove);
       this.pictureBox.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseUp);
+      this.pictureBox.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseWheel);
+
       // 
       // pictureBoxContextMenuStrip
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.cs	(revision 9490)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.cs	(revision 9491)
@@ -166,5 +166,27 @@
     }
 
-    private void ChartControl_KeyDown(object sender, KeyEventArgs e) {
+    protected virtual void pictureBox_MouseWheel(object sender, MouseEventArgs e) {
+      if (e.Delta > 0) {
+        // zoom in
+        double x1 = Chart.LowerLeft.X + Chart.Size.Width / 8;
+        double y1 = Chart.LowerLeft.Y + Chart.Size.Height / 8;
+        double x2 = Chart.UpperRight.X - Chart.Size.Width / 8;
+        double y2 = Chart.UpperRight.Y - Chart.Size.Height / 8;
+        Chart.ZoomIn(x1, y1, x2, y2);
+      } else if (e.Delta < 0) {
+        // zoom out
+        double x1 = Chart.LowerLeft.X - Chart.Size.Width / 8;
+        double y1 = Chart.LowerLeft.Y - Chart.Size.Height / 8;
+        double x2 = Chart.UpperRight.X + Chart.Size.Width / 8;
+        double y2 = Chart.UpperRight.Y + Chart.Size.Height / 8;
+        Chart.ZoomIn(x1, y1, x2, y2);
+      }
+    }
+
+    private void pictureBox_MouseEnter(object sender, EventArgs e) {
+      pictureBox.Focus();
+    }
+
+    protected virtual void ChartControl_KeyDown(object sender, KeyEventArgs e) {
       if (Chart.Mode == ChartMode.Select) {
         if (e.KeyCode == Keys.Delete) {
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.resx
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.resx	(revision 9490)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.resx	(revision 9491)
@@ -113,14 +113,17 @@
   </resheader>
   <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
   <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
-  <metadata name="pictureBoxContextMenuStrip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+  <metadata name="pictureBoxContextMenuStrip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
     <value>102, 17</value>
   </metadata>
-  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
     <value>17, 17</value>
   </metadata>
+  <metadata name="saveFileDialog.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>311, 17</value>
+  </metadata>
 </root>